    // A test-rig for the DynamicProgram class. The name of a class
    // with a no-arg constructor should be passed as a single
    // command line argument. An object of this class will then
    // be dynamically controlled interactively.
class DynamicProgramMain {
    public static void main(String[] args){
        if(args.length != 1){
            System.err.println("Usage: DynamicProgramMain class-name");
        }
        else{
            try{
                // Resolve the class name into a Class
                final Class objectClass = Class.forName(args[0]);
                // Create an object to run the class dynamically.
                final DynamicProgram program = new DynamicProgram(objectClass);
                program.run();
            }
            catch(ClassNotFoundException e){
                System.err.println("Unable to find class: "+args[0]);
            }
        }
    }
}
