    // Detect an ImageProducer returned from URLConnection.getContent
    // and pass it to an ImageViewer for display.
import java.net.*;
import java.awt.image.ImageProducer;

class URLImageProducer {
    public static void main(String[] args) {
        for(int i = 0; i < args.length; i++){
            try{
                URL url = new URL(args[i]);
                URLConnection connection = url.openConnection();
                Object o = connection.getContent();
                // Show an image, if we have one.
                if(o instanceof ImageProducer){
                    new ImageViewer((ImageProducer) o);
                }
                else{
                    System.err.println(
                            "The URL does not appear to refer to an image.");
                }
            }
            catch(Exception e){
                System.err.println("Exception: "+e);
            }
        }
    }
}
